function digglerDoMenu(aEvent)
{
  var id = aEvent.target.getAttribute("id");
  if (id == "diggler-clear") {
    digglerClearLocation();
  }
  else {
    digglerSetUrl(aEvent);
  }
}

function digglerSetUrl(aEvent)
{
  var uriToLoad = aEvent.target.getAttribute("label");
  urlBar = document.getElementById("urlbar");
  urlBar.value = uriToLoad;
  loadURI(uriToLoad);
}

function digglerBuildMenu()
{
  urlBar = document.getElementById("urlbar");
  var url = urlBar.value;

  urlMenu = document.getElementById("diggler-url-menu");

  // The menu seperator will be hidden if there are no items to show for the
  // current url
  var sep = document.getElementById("diggler-menu-seperator");
  var sepVisible = false;

  // Build a list of items from the current url
  digglerClearTempMenuItems(urlMenu);
  if (url.length > 0) {
    sepVisible = true;

    // Regexp to find the last slash delimited chunk of the url
    var reChunk = /[^\/]\/[^\/]+\/*$/; 
    var idx = 0;
    while (1)
    {
      dump("URL part = " + url + "\n");
      digglerCreateTempMenuItem(urlMenu, idx++, url);

      var lastChunk = url.search(reChunk);
      if (lastChunk == -1) {
        break;
      }
      // The + 2 bit is here because we want to slice 2 chars into the regexp
      url = url.slice(0, lastChunk + 2); 
    }
  }

  // Hide the seperator
  sep.setAttribute("hidden", !sepVisible);
}

function digglerClearTempMenuItems(aParent)
{
  var children = aParent.childNodes;
  for (var i = 0; i < children.length; i++)
  {
    var index = children[i].getAttribute("tmp");
    if (index)
      aParent.removeChild(children[i]);
  }
}

function digglerCreateTempMenuItem(aParent, aIndex, aLabel)
{
  var menuitem = document.createElement("menuitem");
  menuitem.setAttribute("label", aLabel);
  menuitem.setAttribute("tmp", aIndex);
  aParent.appendChild(menuitem);
}

function digglerClearLocation()
{
  urlBar = document.getElementById("urlbar");
  urlBar.value = "";
  urlBar.focus();
}

function digglerAbout()
{
}